* PACKAGE P2GRST      !" ʪ(2) ˰
*
*"  [HIS] 95/09/22(ishiwatari)
*"        95/10/05(ishiwatari) ˸Фޤ
*
**********************************************************************
      SUBROUTINE GRVSAT   !" ήĴ
     M         ( GDT   ,
     O           GTGS  ,
     I           GDTM  , GDP   , GDPM  , DELTA  )
*
*   [PARAM] 
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                      !" ʻȿ
      INCLUDE   (ZCCOM)                      !" ɸʪ
#else
#include        "zcdim.F"                    !" ʻȿ
#include        "zccom.F"                    !" ɸʪ
#endif
*
*   [MODIFY] 
      REAL       GDT   ( IDIM*JDIM, KMAX )   !"   
*
*   [INPUT] 
      REAL       GDP   ( IDIM*JDIM, KMAX )   !"   
      REAL       GDPM  ( IDIM*JDIM, KMAX+1 ) !" Ⱦ
      REAL       GDTM  ( IDIM*JDIM, KMAX+1 ) !" ١Ⱦ
      REAL       DELTA                       !" 2 t
*
*   [OUTPUT] 
      REAL       GTGS   ( IDIM*JDIM, KMAX )   !" ѲΨ
*
*   [INTERNAL PARM] 
      REAL       FGS                         !" Ĵ᤹ٹ
      INTEGER    KMINGS                      !" Ĵᳫϥ٥
      INTEGER    KMAXGS                      !" ĴὪλ٥
      DATA       FGS    / 1.0 /
      DATA       KMINGS / 2   /
*"          :KMAXGS ΥǥեͤϲǷ.
*
      NAMELIST /NMGRST/ FGS, KMINGS, KMAXGS
      LOGICAL    OFIRST
      DATA       OFIRST / .TRUE. /
      SAVE
*
*   [INTERNAL WORK] 
      COMMON    /COMWRK/
     &           DELP, TB
      REAL       DELP  ( IDIM*JDIM, KMAX )   !" 
      REAL       TB    ( IDIM*JDIM, KMAX )   !" T ܾ
      INTEGER    IJ, K, K1
      REAL       SUMTDP, SUMADP
      INTEGER    KBOTOM                      !" ʬβ٥
      INTEGER    KTOP                        !" ʬξ٥
*
*
*   [ONCE] 
      IF ( OFIRST ) THEN
         WRITE ( 6,* ) ' GRAVITY WAVE SATURATION P2.1 DATE=95/10/08'
         OFIRST = .FALSE.
*
         KMAXGS = KMAX-1
*
         CALL   REWNML ( IFPAR , JFPAR )
         READ   ( IFPAR, NMGRST, END=190 )
  190    WRITE  ( JFPAR, NMGRST )
*
      ENDIF
*
*"      < 1. ե׻ >
*
      DO 1100 K = 1, KMAX
         DO 1100 IJ = 1, IDIM*JDIM
            DELP  ( IJ,K ) = GDPM( IJ,K   ) - GDPM( IJ,K+1 )
            TB    ( IJ,K ) = (GDTM( IJ,K ) + GDTM( IJ,K+1 ))/2.0
 1100 CONTINUE
*
*"      < 2. Ĵ >
*
      CALL RESET ( GTGS, IDIM*JDIM*KDIM )
*
      DO 2110 IJ = 1, IDIM*JDIM
         SUMTDP=0.0
         SUMADP=0.0
         KBOTOM = 0
         KTOP = KMAX
*
         DO 2120 K = KMINGS, KMAXGS
            IF ( KBOTOM .GE. 1  ) THEN
               SUMTDP =  SUMTDP
     &                    + (TB(IJ,K) - GDT(IJ,K) ) * DELP(IJ,K)
               SUMADP =  SUMADP + DELP(IJ,K)
               IF( (GDT(IJ,K)-GDT(IJ,K-1))*(GDT(IJ,K+1)-GDT(IJ,K))
     &             .GE.0.0 .OR. K .EQ. KMAXGS)  THEN
                  KTOP = K
*"                                 T ׻
                  DO 2210 K1=KBOTOM,KTOP
                     GTGS(IJ,K1) = GTGS(IJ,K1)
     &                    + FGS*(   TB(IJ,K1) - GDT(IJ,K1) 
     &                            - SUMTDP/SUMADP )
 2210             CONTINUE 
*"                              ꥻå
                  SUMTDP=0.0
                  SUMADP=0.0
                  KBOTOM=0
                  KTOP=KMAX
               ENDIF
            ELSE
               IF( (GDT(IJ,K)-GDT(IJ,K-1))*(GDT(IJ,K+1)-GDT(IJ,K))
     &             .LT. 0.0) THEN
*"                           ʬȯ
                  KBOTOM = K-1
                  SUMTDP =  (TB(IJ,K-1) - GDT(IJ,K-1) ) * DELP(IJ,K-1)
     &                    + (TB(IJ,K) - GDT(IJ,K) ) * DELP(IJ,K)
                  SUMADP =  DELP(IJ,K-1) + DELP(IJ,K)
               ENDIF
            ENDIF
 2120    CONTINUE
*
         DO 2140 K=1,KMAX
            GDT(IJ,K) = GDT(IJ,K) + GTGS(IJ,K)
            GTGS(IJ,K) = GTGS(IJ,K)/DELTA
 2140    CONTINUE
 2110 CONTINUE
*
      RETURN
      END
