* PACKAGE P2ICEM  !" ʪ(2) ɹǥ
*
*"                ɽ̲٤˱ɹĥ餹
*" 98/11/19             
*"
***********************************************************************
      SUBROUTINE SEAICE
     M         ( GDHI  , GDTO  , 
     M           GTTG  ,
     I           GDTG  , 
     I           TFLUX , QFLUX , RFLUX , SFLUX ,
     I           DELTM                                   )
*
*   [PARAM] 
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                      !" ʻȿ
      INCLUDE   (ZHDIM)                      !" ʸʸ
#else
#include        "zcdim.F"                    !" ʻȿ
#include        "zhdim.F"                    !" ʸʸ
#endif
*
*   [MODIFY] 
      REAL       GDHI  ( IDIM*JDIM       )   !" ɹθ
      REAL       GDTO  ( IDIM*JDIM       )   !" κز
*   [INPUT] 
      REAL       GDTG  ( IDIM*JDIM )         !" ɽ̲
      REAL       GTTG  ( IDIM*JDIM )         !" ɽѲΨ
      REAL       TFLUX ( IDIM*JDIM, KMAX+1 ) !" ԤΥեå
      REAL       QFLUX ( IDIM*JDIM, KMAX+1 ) !" Υեå
      REAL       RFLUX ( IDIM*JDIM, KMAX+1 ) !" Ĺȥեå
      REAL       SFLUX ( IDIM*JDIM, KMAX+1 ) !" ûȥեå
*
      REAL       DELTM                       !" ǥֹ t
*
      LOGICAL    OFIRST
      DATA       OFIRST / .TRUE. /
      SAVE
*
*   [INTERNAL WORK] 
      REAL       FM                          !" ɹɽز
      REAL       FB                          !" ɹɽز
      REAL       FT                          !" ɹɽز
      REAL       QM                          !" ɹɽز
      REAL       QMALL                       !" ɹɽز
      REAL       NGDHI                       !" ѿ( Hi)
      REAL       NGDTT                       !" ѿ( Tt)

      INTEGER    ITIM
      REAL       DELTICE                     !" ice model t

      COMMON    /COMWRK/
     &           GDTT, GBTG
      REAL       GDTT  ( IDIM*JDIM )         !" ɹɽز
      REAL       GBTG  ( IDIM*JDIM )         !" ƥåɽ̲
*
*   [INTERNAL PARM] 
      REAL       HIMIN                       !" ICE κǾ
      REAL       TB                          !" ICE β
      REAL       TFREZ                       !" ɹ
      REAL       TMELT                       !" melting point
      REAL       ELF                         !"  <-> ɹ Ǯ
      REAL       ELC                         !" <->ɹ Ǯ
      REAL       CW                          !" Ǯ
      REAL       CICE                        !" ICE Ǯ
      REAL       RHOW                        !" ̩
      REAL       RHOI                        !" ICE ̩
      REAL       DMIXL                       !" ؤθ
      REAL       KW                          !" Ǯ͢
      REAL       KICE                        !" ICE Ǯ͢
      REAL       HS6                         !" ʿǮflux
      INTEGER    NSTPIM                      !" ƥå׿
      DATA       HIMIN  /       0.02 /
      DATA       TB     /     271.0  /
      DATA       TFREZ  /     271.0  /
      DATA       TMELT  /     272.9  /
      DATA       ELF    /  330000.0  /
      DATA       ELC    / 2500000.0  /
      DATA       CW     /    4220.0  /
      DATA       CICE   /    2100.0  /
      DATA       RHOW   /    1000.0  /
      DATA       RHOI   /     900.0  /
      DATA       DMIXL  /      50.0  /
      DATA       KW     /     400.0  /
      DATA       KICE   /       2.0  /
      DATA       HS6    /       0.0  /
      DATA       NSTPIM /       100  /
      NAMELIST   /NMICEM/ HIMIN, TB, TFREZ, TMELT,ELF, ELC, CW, CICE, 
     &                    RHOW, RHOI, DMIXL, KW, KICE, HS6, NSTPIM
*
*   [ONCE] 
      IF ( OFIRST ) THEN
         OFIRST = .FALSE.
         WRITE ( 6,* ) ' ICE MODEL DATE(only putting ice)=99/01/30'
*
         CALL   REWNML ( IFPAR , JFPAR )
         READ   ( IFPAR, NMICEM, END=1190 )
 1190    WRITE  ( JFPAR, NMICEM )
      ENDIF
*
      DO 1100 IJ = 1, IDIM*JDIM
         GBTG( IJ ) = GDTG( IJ )
 1100 CONTINUE
*
      DO 2100 IJ = 1, IDIM*JDIM
         GDTT( IJ ) = GBTG( IJ ) + GTTG( IJ ) * DELTM
         IF ( GDTT  ( IJ ) .LE. TFREZ) THEN  !" ǽɹĥ
            GDHI( IJ ) = HIMIN
            GDTO( IJ ) = GDTT( IJ ) 
         ELSE                                !" ɹ̵
            GDHI( IJ ) = 0.0
            GDTO( IJ ) = GDTT( IJ )
         END IF
 2100 CONTINUE
*
      RETURN
      END

