* PACKAGE P2RADM   !" ʪ(2) (¿)*
*
*"  93/08/29 ݺ            Ĺѹ
*"  94/10/07             GDT -> GDTM
*"  94/11/08             Х
*********************************************************************
      SUBROUTINE RADFLX            !" ͥեå
     O         ( RFLUX , RMTXS , DRFLUX,
     O           SFLUX ,
     I           GDTM  , GDTG  , GDQ   , GDPM  ,
     I           IT    , IDATE , 
     C           ALON  , ALAT  , GRALB          )
*
*"       絤
*
*   [PARAM] 
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                      !" ʻȿ
      INCLUDE   (ZCCOM)                      !" ɸʪ
#else
#include        "zcdim.F"                    !" ʻȿ
#include        "zccom.F"                    !" ɸʪ
#endif
*
*   [OUTPUT] 
      REAL       RFLUX  ( IDIM*JDIM, KMAX+1 )     !" Ĺȥեå
      REAL       RMTXS  ( IDIM*JDIM,  -1:1 )      !" Աɽ
      REAL       DRFLUX ( IDIM*JDIM, KMAX+1, 0:1 )!" ĹɽѲ
      REAL       SFLUX  ( IDIM*JDIM, KMAX+1 )     !" ͥեå
*
*   [INPUT] 
      REAL       GDTM   ( IDIM*JDIM, KMAX+1 ) !" (Ⱦ)  
*                                                !" ݺ 93/08/29 GDTM  
*                                                !"  94/10/07 GDTM ᤹
      REAL       GDTG   ( IDIM*JDIM )         !" ɽ̲
      REAL       GDQ    ( IDIM*JDIM, KMAX )   !" 漾  
      REAL       GDPM   ( IDIM*JDIM, KMAX+1 ) !" (Ⱦ)
      INTEGER    IT                           !" 
      INTEGER    IDATE  ( 6 )                 !" 
*
      REAL       ALON   ( IDIM )              !" 
      REAL       ALAT   ( JDIM )              !" 
      REAL       GRALB  ( IDIM*JDIM )         !" ɽ٥
*
*   [INTERNAL PARM]
      CHARACTER  TUNIT *4                     !" INTLNGñ
      INTEGER    INTLNG                       !" Ĺȷ׻ֳ
      INTEGER    INTSHT                       !" ûȷ׻ֳ
      DATA       TUNIT  / 'HOUR'/
      DATA       INTLNG / 3     /
      DATA       INTSHT / 1     /
*
      NAMELIST  /NMRADM/ TUNIT , INTLNG, INTSHT
*
*   [INTERNAL SAVE] 
      REAL       GDTZ  ( IDIM*JDIM    )       !" ΥƥåפǤβ 
*                                                !" ݺ 93/08/29 ɲ
      REAL       GDTGZ ( IDIM*JDIM    )       !" Υƥåפɽ̲ 
*                                                !"  94/10/07 ɲ
*
      INTEGER    IORADL                       !" Ĺȷ׻ֳ֡
      INTEGER    IORADS                       !" ûȷ׻ֳ֡
      INTEGER    ITLSTL                       !" Ĺȷ׻
      INTEGER    ITLSTS                       !" ûȷ׻
*
      LOGICAL    OFIRST
      DATA       OFIRST / .TRUE. /
      SAVE
*
*   [INTERNAL WORK] 
      COMMON    /COMWRK/
     &           TAUQ  , TAUA   , TRNSM1, TRNSM2, TRANS ,
     &           PIB   , PIBGND , SECZET
      REAL       TAUQ   ( IDIM*JDIM, KMAX+1 ) !" Ū
      REAL       TAUA   ( IDIM*JDIM, KMAX+1 ) !" Ū
      REAL       TRNSM1 ( IDIM*JDIM, KMAX+1 ) !" 1/2 ٥뤫Ʃ᷸
      REAL       TRNSM2 ( IDIM*JDIM, KMAX+1 ) !" 3/2 ٥뤫Ʃ᷸
*                                                 !" ݺ 93/08/29 ɲ
      REAL       TRANS  ( IDIM*JDIM, KMAX+1 ) !" Ʃ᷸
      REAL       PIB    ( IDIM*JDIM, KMAX+1 ) !" У¡ң**4
      REAL       PIBGND ( IDIM*JDIM )         !" ɽΦУ
      REAL       SECZET ( IDIM*JDIM )         !" sec(ͳ)
*
      INTEGER    IJ, K
      INTEGER    IFPAR, JFPAR
*
*   [ONCE]
      IF ( OFIRST ) THEN
         WRITE ( 6,* ) ' GREY RADIATION PACKAGE - DATE=94/11/08'
         OFIRST = .FALSE.
*
         CALL   REWNML ( IFPAR , JFPAR )
         READ   ( IFPAR, NMRADM, END=190 )
  190    WRITE  ( JFPAR, NMRADM )
*
         CALL ACTIME
     I      ( INTLNG, TUNIT  , '#'    ,
     O        IORADL                    )
         CALL ACTIME
     I      ( INTSHT, TUNIT  , '#'    ,
     O        IORADS                   )
         ITLSTL = IT - IORADL
         ITLSTS = IT - IORADS
      ENDIF
*
*"         < 1.  η׻ >
*
      CALL RESET ( TAUQ ( 1,KMAX+1 ), IDIM*JDIM )
      CALL RESET ( TAUA ( 1,KMAX+1 ), IDIM*JDIM )
      DO 1110  K = KMAX, 1, -1
         DO 1120 IJ = 1, IDIM*JDIM
            TAUQ ( IJ,K ) = TAUQ ( IJ,K+1 )
     &                       + GDQ( IJ,K )
     &                         * ( GDPM( IJ,K )-GDPM( IJ,K+1 ) )/ GRAV
            IF( GDQ(IJ,K) .GE. 1.0 ) THEN
               TAUA ( IJ,K ) = TAUA ( IJ,K+1 )
            ELSE IF( GDQ(IJ,K) .GE. 0.0 ) THEN
               TAUA ( IJ,K ) =   TAUA ( IJ,K+1 ) 
     &                         + (1.0-GDQ(IJ,K))
     &                          *( GDPM( IJ,K )-GDPM( IJ,K+1 ) )/ GRAV
            ELSE
               TAUA ( IJ,K ) = TAUA ( IJ,K+1 )
     &                       +   ( GDPM( IJ,K )-GDPM( IJ,K+1 ) )/ GRAV
               WRITE ( 6,* ) ' ***ERROR*** LONG RAD:q<0 at(ij,k)',ij,k
            END IF
 1120    CONTINUE
 1110 CONTINUE
*
c$$$      write (6,*) 'in p2radmN:ij,k,tauq,taua'
c$$$      do 1 ij=1,idim*jdim
c$$$         do 1 k=1,kmax
c$$$            write (6,*) ij,k,tauq(ij,k),taua(ij,k)
c$$$ 1    continue 
*
*
      IF (  ( IT - ITLSTL ) .GE. IORADL ) THEN
*
         ITLSTL = IT
*
c$$$         write (6,*) 'in p2radmN:before lngflx'
*"         < 2. Ĺȥեåλ >     !"  ݺ 93/08/29 ѹ
*
         CALL LNGFLX
     O         ( RFLUX , DRFLUX,
     I           GDTM  , GDTG  , TAUQ  , TAUA  ,
     W           TRNSM1, TRNSM2, TRANS , PIB   , PIBGND  )
*
      ELSE 
*
c$$$         write (6,*) 'in p2radmN:before radiation correction'
         DO 2000 K = 1, KMAX+1             
            DO 2000 IJ = 1, IDIM*JDIM
               RFLUX ( IJ,K ) = RFLUX ( IJ,K ) 
     &                        + DRFLUX ( IJ,K,0 ) 
     &                           * ( GDTG ( IJ ) - GDTGZ ( IJ ) )
     &                        + DRFLUX ( IJ,K,1 ) 
     &                           * ( GDTM ( IJ,1 ) - GDTZ ( IJ ) )
               DRFLUX ( IJ,K,0 ) = DRFLUX ( IJ,K,0 ) 
     &                             / GDTGZ ( IJ   )**3
     &                             * GDTG  ( IJ )**3
               DRFLUX ( IJ,K,1 ) = DRFLUX ( IJ,K,1 ) 
     &                             / GDTZ ( IJ   )**3
     &                             * GDTM  ( IJ,1 )**3
 2000    CONTINUE

      ENDIF
*
      DO 2100 IJ = 1, IDIM*JDIM
         GDTZ  ( IJ ) = GDTM ( IJ , 1 )
         GDTGZ ( IJ ) = GDTG ( IJ )
 2100 CONTINUE
*
*"         < 3. Ĺȱѹ >             !" ݺ 93/08/29 ѹ
*
      DO 3100 IJ = 1, IDIM*JDIM
         RMTXS ( IJ,0  ) =   DRFLUX( IJ,1,0 )
         RMTXS ( IJ,1  ) =   DRFLUX( IJ,1,1 )
         RMTXS ( IJ,-1 ) = 0.  
 3100 CONTINUE
*
*
      IF (  ( IT - ITLSTS ) .GE. IORADS ) THEN
*
         ITLSTS = IT
*
*"         < 4. û >
*
         CALL SHTINS
     O         ( SFLUX(1,KMAX+1), SECZET ,
     I           IDATE ,
     C           ALON  , ALAT             )
*
*"         < 5. ûȥեå >
*
         CALL SHTFLX
     M         ( SFLUX ,
     I           TAUQ  , TAUA  , SECZET,
     C           GRALB                  )
*
      ENDIF
*
      RETURN
      END
************************************************************************
      SUBROUTINE RADCOR                      !" ͥեå
     O         ( RFLUXC ,
     I           RFLUX  , DRFLUX, GTT   , GTTG  , DELT  )
*
*   [PARAM] 
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                       !" ʻȿ
#else
#include        "zcdim.F"                     !" ʻȿ
#endif
*
*   [OUTPUT] 
      REAL       RFLUXC ( IDIM*JDIM, KMAX+1 )    !" Ĺȥեå 
*
*   [INPUT] 
      REAL       RFLUX  ( IDIM*JDIM, KMAX+1 )    !" Ĺȥեå
      REAL       DRFLUX ( IDIM*JDIM, KMAX+1, 0:1 )!" ĹɽѲ
      REAL       GTT    ( IDIM*JDIM, KMAX )       !" ٻѲ
      REAL       GTTG   ( IDIM*JDIM )             !" ɽѲΨ
      REAL       DELT                             !" ֹߦt
*
*   [INTERNAL WORK] 
      INTEGER    IJ, K
*
*"  <  ͥեå >                    !" 93/08/29 ѹ
*
      DO 1100 K = 1, KMAX+1
         DO 1100 IJ = 1, IDIM*JDIM
            RFLUXC ( IJ,K ) = RFLUX ( IJ,K )
     &                      + (  GTTG ( IJ )   * DRFLUX ( IJ,K,0 ) 
     &                         + GTT  ( IJ,1 ) * DRFLUX ( IJ,K,1 ) )
     &                        * DELT 
 1100 CONTINUE
*
      RETURN
      END
*********************************************************************
      SUBROUTINE RADTND               !" ͲǮΨ
     O         ( GTTRL , GTTRS ,
     I           RFLUX , SFLUX , GDPM    )
*
*   [PARAM] 
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                       !" ʻȿ
      INCLUDE   (ZCCOM)                       !" ɸʪ
#else
#include        "zcdim.F"                     !" ʻȿ
#include        "zccom.F"                     !" ɸʪ
#endif
*
*   [OUTPUT] 
      REAL       GTTRL  ( IDIM*JDIM, KMAX   ) !" ĹȲǮΨ
      REAL       GTTRS  ( IDIM*JDIM, KMAX   ) !" ûȲǮΨ
*
*   [INPUT] 
      REAL       RFLUX  ( IDIM*JDIM, KMAX+1 ) !" Ĺȥեå
      REAL       SFLUX  ( IDIM*JDIM, KMAX+1 ) !" ûȥեå
      REAL       GDPM   ( IDIM*JDIM, KMAX+1 ) !" 
*
*   [INTERNAL WORK] 
      INTEGER    IJ, K
*
*
      DO 1100 K = 1, KMAX
         DO 1110 IJ = 1, IDIM*JDIM
            GTTRL ( IJ,K )
     &         =  (  RFLUX( IJ,K ) - RFLUX( IJ,K+1 )   )
     &           /(  GDPM ( IJ,K ) - GDPM ( IJ,K+1 )   )
     &           / CP * GRAV
 1110    CONTINUE
 1100 CONTINUE
*
      DO 2100 K = 1, KMAX
         DO 2110 IJ = 1, IDIM*JDIM
            GTTRS ( IJ,K )
     &         =  (  SFLUX( IJ,K ) - SFLUX( IJ,K+1 )  )
     &           /(  GDPM ( IJ,K ) - GDPM ( IJ,K+1 )   )
     &           / CP * GRAV
 2110    CONTINUE
 2100 CONTINUE
*
      RETURN
      END
