* PACKAGE P2SFCM  !" ʪ(2) ɽեå
*
***********************************************************************
      SUBROUTINE SFCUVT           !"  ɽեå
     M         ( UFLUX , VFLUX , TFLUX , QFLUX ,
     M           UMTXS , TMTXS , QMTXS ,
     I           GDU   , GDV   , GDT   , GDTM  , GDTG  , GDQ   ,
     I           GDP   , GDPM  , GDZ   ,
     I           GRBET , GRZ0  , IDSFC                          )
*
*   [PARAM] 
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                      !" ʻ, ȿ
      INCLUDE   (ZCCOM)                      !" ɸʪ
#else
#include        "zcdim.F"                    !" ʻ, ȿ
#include        "zccom.F"                    !" ɸʪ
#endif
*
*   [MODIFY] 
      REAL       UFLUX ( IDIM*JDIM, KMAX+1 ) !" դΥեå
      REAL       VFLUX ( IDIM*JDIM, KMAX+1 ) !" ֤Υեå
      REAL       TFLUX ( IDIM*JDIM, KMAX+1 ) !" ԤΥեå
      REAL       QFLUX ( IDIM*JDIM, KMAX+1 ) !" Υեå
*
      REAL       UMTXS ( IDIM*JDIM )             !" ɽ
      REAL       TMTXS ( IDIM*JDIM , 0:1, -1:1 ) !" Աɽ
      REAL       QMTXS ( IDIM*JDIM , 0:1, -1:1 ) !" 񱢲ɽ
*
*   [INPUT] 
      REAL       GDU   ( IDIM*JDIM, KMAX )   !"   
      REAL       GDV   ( IDIM*JDIM, KMAX )   !"   
      REAL       GDT   ( IDIM*JDIM, KMAX )   !"   
c      REAL       GDTM  ( IDIM*JDIM, KMAX )   !" ١Ⱦ
      REAL       GDTM  ( IDIM*JDIM, KMAX+1 )   !" ١Ⱦ
      REAL       GDTG  ( IDIM*JDIM       )   !" ɽ̲
      REAL       GDQ   ( IDIM*JDIM, KMAX )   !" 漾  
      REAL       GDP   ( IDIM*JDIM, KMAX )   !" 
c      REAL       GDPM  ( IDIM*JDIM, KMAX )   !" Ⱦ
      REAL       GDPM  ( IDIM*JDIM, KMAX+1 )   !" Ⱦ
      REAL       GDZ   ( IDIM*JDIM, KMAX )   !" 
*
      REAL       GRBET ( IDIM*JDIM )         !" ɽ٦
      REAL       GRZ0  ( IDIM*JDIM )         !" ɽĹ
      INTEGER    IDSFC ( IDIM*JDIM )         !" ɽ
*
*   [INTERNAL PARM] 
      REAL       P00, THS
      REAL       URMIN
      REAL       USMINM, USMINH, USMINE
      REAL       USMAXM, USMAXH, USMAXE
      REAL       DELQ
      DATA       P00   / 100000. /
      DATA       THS   / 300.    /            !" ܲ
      DATA       URMIN / 0.01    /            !" ңǾ
      DATA       USMINM/ 0.01    /            !" ưǾ
      DATA       USMINH/ 0.01    /            !" ǮǾ
      DATA       USMINE/ 0.01    /            !" Ǿ
      DATA       USMAXM/ 1000.   /            !" ư
      DATA       USMAXH/ 1000.   /            !" Ǯ
      DATA       USMAXE/ 1000.   /            !" 
      DATA       DELQ  / 0.1     /            !" ѥ᡼
*
      NAMELIST  /NMSFCM/ THS   , URMIN ,
     &                   USMINM, USMAXM,
     &                   USMINH, USMAXH,
     &                   USMINE, USMAXE,
     &                   DELQ
*
      LOGICAL    OFIRST
      DATA       OFIRST / .TRUE. /
      SAVE
*
*   [INTERNAL WORK] 
      COMMON    /COMWRK/
     &           EXNER , VABS  , RIB   ,
     &           CMV   , CHV   , CEV   ,
     &           QSAT  , DQSAT
      REAL       EXNER ( IDIM*JDIM )         !" 絤Exnerؿ
      REAL       VABS  ( IDIM*JDIM )         !" ®
      REAL       RIB   ( IDIM*JDIM )         !" Х륯ң
      REAL       CMV   ( IDIM*JDIM )         !" Х륯͢
      REAL       CHV   ( IDIM*JDIM )         !" Х륯͢
      REAL       CEV   ( IDIM*JDIM )         !" Х륯͢
      REAL       QSAT  ( IDIM*JDIM )         !" ɽ˰漾
      REAL       DQSAT ( IDIM*JDIM )         !" ɽ˰漾Ѳ
*
      INTEGER    IJ
      INTEGER    IFPAR, JFPAR
      REAL       AKAPPA
*
#ifdef SYS_IBMS
      INCLUDE   (ZQSAT)                      !" ˰漾
#else
#include        "zqsat.F"                    !" ˰漾
#endif
*
      IF ( OFIRST ) THEN
         WRITE ( 6,* ) ' SURFACE FLUX(dust) - P2.1a DATE=97/06/25'
         OFIRST = .FALSE.
*
         CALL   REWNML ( IFPAR , JFPAR )
         READ   ( IFPAR, NMSFCM, END=190 )
  190    WRITE  ( JFPAR, NMSFCM )
*
      ENDIF
*
      AKAPPA = RAIR / CP
      DO 100 IJ = 1, IDIM*JDIM
         EXNER ( IJ ) = ( GDP ( IJ,1 )/GDPM( IJ,1 ) ) ** AKAPPA
  100 CONTINUE
*
*"         < 1. Х륯ң >
*
      DO 1100 IJ = 1, IDIM*JDIM
         VABS ( IJ ) = SQRT( GDU( IJ,1 )**2+GDV( IJ,1 )**2 )
         RIB  ( IJ ) = GRAV / THS
     &                * (   GDT ( IJ,1 )/EXNER ( IJ ) 
     &                    - GDTG( IJ   )              )
     &                / MAX( VABS( IJ ), URMIN )**2 * GDZ( IJ,1 )
 1100 CONTINUE
*
*"         < 3. Х륯 >
*
      CALL BLKCOF
     O         ( CMV   , CHV   , CEV   ,
     I           RIB   , VABS  , GRZ0  , GRZ0  , GDZ   )
*
*"         < 4. Х륯͢ >
*
c$$$      write(6,*) 'in SFCUVT;ij,cmv,chv,cev'
      DO 4100 IJ = 1, IDIM*JDIM
         CMV  ( IJ ) = CMV ( IJ )
     &                 * GDPM( IJ,1 ) / ( RAIR * GDTM( IJ,1 ) )
     &                 * MIN( MAX ( VABS( IJ ), USMINM ), USMAXM )
         CHV  ( IJ ) = CHV ( IJ )
     &                 * GDPM( IJ,1 ) / ( RAIR * GDTM( IJ,1 ) )
     &                 * MIN( MAX ( VABS( IJ ), USMINH ), USMAXH )
         CEV  ( IJ ) = CEV ( IJ )
     &                 * GDPM( IJ,1 ) / ( RAIR * GDTM( IJ,1 ) )
     &                 * MIN( MAX ( VABS( IJ ), USMINE ), USMAXE )
c$$$         write(6,*) ij,cmv(ij),chv(ij),cev(ij)
 4100 CONTINUE
*
*"         < 5. ˰漾  >
*
c$$$      DO 5100 IJ = 1, IDIM*JDIM
c$$$         QSAT ( IJ ) = FQSAT ( GDTG( IJ ), GDPM( IJ,1 ) )
c$$$         DQSAT( IJ ) = FDQSAT( GDTG( IJ ), QSAT( IJ )   )
c$$$ 5100 CONTINUE
*
*"         < 6. եå >
*
c$$$         write (6,*) 'in p2sfcm;ij,tflux(before)'
c$$$         write (6,*) 'in p2sfcm:cp,chv,gdtg'
c$$$         write (6,*) 'in p2sfcm:gdt,exner,tflux(after)'
      DO 6100 IJ = 1, IDIM*JDIM
         UFLUX( IJ,1 ) = UFLUX( IJ,1 )
     &                         - CMV ( IJ ) * GDU( IJ,1 )
         VFLUX( IJ,1 ) = VFLUX( IJ,1 )
     &                         - CMV ( IJ ) * GDV( IJ,1 )
c$$$         write (6,*) ij,tflux(ij,1)
         TFLUX( IJ,1 ) = TFLUX( IJ,1 )
     &                   + CP *  CHV ( IJ )
     &                        *(   GDTG( IJ )
     &                           - GDT ( IJ,1 )/EXNER ( IJ )   )
c$$$         write (6,*) cp,chv(ij),gdtg(ij)
c$$$         write (6,*) gdt(ij,1),exner(ij),tflux(ij,1)
c$$$         QFLUX( IJ,1 ) = QFLUX( IJ,1 )
c$$$     &                   + EL *  CEV ( IJ ) * GRBET( IJ )
c$$$     &                        *( QSAT( IJ ) - GDQ ( IJ,1 ) )
         QFLUX( IJ,1 ) = QFLUX( IJ,1 )
     &                   + EL *  CEV ( IJ ) * GRBET( IJ )
     &                        * DELQ
 6100 CONTINUE
*
*"       < 7. ѹ >
*
      CALL RESET ( TMTXS, IDIM*JDIM*6 )
      CALL RESET ( QMTXS, IDIM*JDIM*6 )
*
      DO 7100 IJ = 1, IDIM*JDIM
         UMTXS( IJ )      =         CMV( IJ )
*
         TMTXS( IJ,1,0  ) =    CP * CHV( IJ ) / EXNER( IJ )
         TMTXS( IJ,0,1  ) =  - CP * CHV( IJ ) / EXNER( IJ )
*
c         QMTXS( IJ,1,0  ) =    CP * CEV( IJ ) * GRBET( IJ )
c         QMTXS( IJ,0,1  ) =  - CP * CEV( IJ ) * GRBET( IJ )
         QMTXS( IJ,1,0  ) =    CP * CEV( IJ ) * GRBET( IJ )
         QMTXS( IJ,0,1  ) =    0.0
*
         IF ( IDSFC( IJ ) .GE. 1 ) THEN
*
            TMTXS( IJ,1,-1 ) = - CP * CHV( IJ )
            TMTXS( IJ,0,0  ) =   CP * CHV( IJ )
*
c            QMTXS( IJ,1,-1 ) = - EL * CEV( IJ ) * GRBET( IJ )
c     &                                          * DQSAT( IJ )
c            QMTXS( IJ,0,0  ) =   EL * CEV( IJ ) * GRBET( IJ )
c     &                                          * DQSAT( IJ )
            QMTXS( IJ,1,-1 ) = 0.0
            QMTXS( IJ,0,0  ) = 0.0
         ENDIF
*
 7100 CONTINUE
*
      RETURN
      END
