*PACKAGE P2ZFLT  !" $BJ*M}2aDx(B(2) $B1tD>J}8~$K%U%#%k%?$r$+$1$k(B
*
*"$BMzNr(B 95/04/05 $B@PEO@5<y(B            
*"$BMzNr(B 95/05/02 $B@PEO@5<y(B            
*"$BMzNr(B 95/10/30 $B@PEO@5<y(B : T $B$N8m:9$O(B $B6I=jE*$KJd@5(B
*"                         U, V $B$O$=$N$^$^(B 
***********************************************************************
      SUBROUTINE VERFLT      !" $B1tD>J}8~$N%U%#%k%?(B
     M         ( GDU  , GDV  , GDT  ,
     O           GTUZF, GTVZF, GTTZF,
     I           DELTA, GDPM  ) 
*
*"  $B1tD>J}8~$N%U%#%k%?(B: Shapiro (1971)
*"  $B8m:9$O$=$l$>$l(Blocal $B$K$P$i$^$/(B.
*
*   [PARAM] 
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                      !" $B3J;RE@?t!$GH?t(B
      INCLUDE   (ZCCOM)                      !" $BI8=`J*M}Dj?t(B
#else
#include        "zcdim.F"                    !" $B3J;RE@?t!$GH?t(B
#include        "zccom.F"                    !" $BI8=`J*M}Dj?t(B
#endif
*
*   [MODIFY] 
      REAL       GDT   ( IDIM*JDIM, KMAX )  !" $B29EY(B   $B#T(B
      REAL       GDU   ( IDIM*JDIM, KMAX )  !" $BEl@>Iw(B $B#U(B
      REAL       GDV   ( IDIM*JDIM, KMAX )  !" $BFnKLIw(B $B#V(B
*
*   [INPUT]
      REAL       GDPM  ( IDIM*JDIM, KMAX+1 )  !" p ($BH>@0?t(B)
*
*   [INPUT]
      REAL    DELTA
*
*   [INTERNAL PARM]
      REAL    SH                               !" $B%U%#%k%?78?t(B
      REAL    SM                               !" $B%U%#%k%?78?t(B
      DATA    SH / 0.5 /
      DATA    SM / 0.5 /
*
      NAMELIST  /NMZFLT/ SH,SM
      SAVE
*
*   [INTERNAL WORK] 
      INTEGER    IJ, K
      INTEGER    IFPAR, JFPAR
      REAL       TCOR  ( IDIM*JDIM, KMAX )  !" $B29EYJd@5J,(B
      REAL       DELP  ( IDIM*JDIM, KMAX )  !" $B&$(Bp 
*
*   [OUTPUT] 
      REAL       GTTZF   ( IDIM*JDIM, KMAX )   !" $B%U%#%k%?#TJQ2=N((B
      REAL       GTUZF   ( IDIM*JDIM, KMAX )   !" $B%U%#%k%?#UJQ2=N((B
      REAL       GTVZF   ( IDIM*JDIM, KMAX )   !" $B%U%#%k%?#VJQ2=N((B
*
*   [INTERNAL SAVE] 
      LOGICAL    OFIRST
      DATA       OFIRST / .TRUE. /
      SAVE
*
*   [ONCE]
      IF ( OFIRST ) THEN
         WRITE ( 6,* ) ' Z FILTER PACKAGE(err->local) - DATE=95/11/04'
         OFIRST = .FALSE.
*
         CALL   REWNML ( IFPAR , JFPAR )
         READ   ( IFPAR, NMZFLT, END=190 )
  190    WRITE  ( JFPAR, NMZFLT )
      ENDIF
*
*"   < 1. $B&$(Bp$B7W;;!&%j%;%C%H(B>
*
      DO 1100 K = 1, KMAX
         DO 1100 IJ = 1, IDIM*JDIM
            DELP  ( IJ,K ) = GDPM( IJ,K ) - GDPM( IJ,K+1 )
 1100 CONTINUE
      CALL RESET ( GTTZF, IDIM*JDIM*KMAX )
      CALL RESET ( GTUZF, IDIM*JDIM*KMAX )
      CALL RESET ( GTVZF, IDIM*JDIM*KMAX )
*
*"   < 2. U, V $B$ND4@a(B >
*
      DO 2200 IJ=1,IDIM*JDIM
         GTUZF(IJ,1) = SM/2.0*(GDU(IJ,2)-GDU(IJ,1))
         GTVZF(IJ,1) = SM/2.0*(GDV(IJ,2)-GDV(IJ,1))
         DO 2100 K=2, KMAX-1
               GTUZF(IJ,K)
     &       = SM/2.0*(GDU(IJ,K-1)-2.0*GDU(IJ,K)+GDU(IJ,K+1))
               GTVZF(IJ,K)
     &       = SM/2.0*(GDV(IJ,K-1)-2.0*GDV(IJ,K)+GDV(IJ,K+1))
 2100    CONTINUE 
         GTUZF(IJ,KMAX)
     &      = SM/2.0*(GDU(IJ,KMAX-1)-GDU(IJ,KMAX))
         GTVZF(IJ,KMAX)
     &      = SM/2.0*(GDV(IJ,KMAX-1)-GDV(IJ,KMAX))
 2200 CONTINUE 
*
*"   < 3. T $B$ND4@a(B >
*
      DO 3010 IJ=1,IDIM*JDIM
*
*"       < 3.1 $BJd@59`7W;;(B >
         TCOR(IJ,1)
     &      =  - GDT(IJ,1) * ( DELP(IJ,2) - DELP(IJ,1) )
     &                        / ( DELP(IJ,2) + DELP(IJ,1) )
         DO 3110 K=2, KMAX-1
            TCOR(IJ,K) 
     &        = - GDT(IJ,K) 
     &            * (   DELP(IJ,K+1) - 2.0 * DELP(IJ,K)
     &                + DELP(IJ,K-1) )
     &            / ( DELP(IJ,K+1) + DELP(IJ,K) + DELP(IJ,K-1) )
 3110    CONTINUE 
         TCOR(IJ,KMAX)
     &      =  - GDT(IJ,KMAX) * ( - DELP(IJ,KMAX) + DELP(IJ,KAMX-1) )
     &                    / (   DELP(IJ,KMAX) + DELP(IJ,KAMX-1) )
*
*"       < 3.2 $B29EYJQ2=NL(B >
         GTTZF(IJ,1) = SH/2.0*
     &        (  GDT(IJ,2) - GDT(IJ,1)
     &         +  TCOR(IJ,2) + TCOR(IJ,1) )
         DO 3210 K=2, KMAX-1
            GTTZF(IJ,K) = SH/2.0*
     &       (   GDT(IJ,K-1)-2.0*GDT(IJ,K)+GDT(IJ,K+1)
     &         + TCOR(IJ,K+1) + TCOR(IJ,K) + TCOR(IJ,K-1) )
 3210    CONTINUE 
         GTTZF(IJ,KMAX) = SH/2.0*
     &        (   GDT(IJ,KMAX-1) - GDT(IJ,KMAX) 
     &          + TCOR(IJ,KMAX-1) + TCOR(IJ,KMAX) )
 3010 CONTINUE 
*
*"   < 4. $BJQ2=NL(B, $BJQ2=N(7hDj(B >
*
      DO 4100 IJ = 1, IDIM*JDIM
         DO 4100 K=1,KMAX
            GDU(IJ,K)   = GDU(IJ,K) + GTUZF(IJ,K)
            GDV(IJ,K)   = GDV(IJ,K) + GTVZF(IJ,K)
            GDT(IJ,K)   = GDT(IJ,K) + GTTZF(IJ,K)
            GTUZF(IJ,K) = GTUZF(IJ,K)/DELTA
            GTVZF(IJ,K) = GTVZF(IJ,K)/DELTA
            GTTZF(IJ,K) = GTTZF(IJ,K)/DELTA
 4100 CONTINUE 
*
      RETURN
      END


