*"   PACKAGE  
* PACKAGE P2RDLN  !" ʪ(2) Ĺ(¿) 
*
*"  93/08/29 ݺ            Ĺѹ
*"  94/07/16             ͷ׻
***********************************************************************
      SUBROUTINE LNGFLX           !" Ĺͥեå
     O         ( RFLUX , DRFLUX,
     I           GDT   , GDTG  , TAUQ  , TAUA  ,
     W           TRNSM1, TRNSM2, TRANS , PIB   , PIBGND  )
*
*   [PARAM] 
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                       !" ʻȿ
      INCLUDE   (ZCCOM)                       !" ɸʪ
#else
#include        "zcdim.F"                     !" ʻȿ
#include        "zccom.F"                     !" ɸʪ
#endif
*
*   [OUTPUT] 
      REAL       RFLUX  ( IDIM*JDIM, KMAX+1 )     !" Ĺȥեå
      REAL       DRFLUX ( IDIM*JDIM, KMAX+1, 0:1 )!" ĹɽѲ
*
*   [INPUT] 
      REAL       GDT    ( IDIM*JDIM, KMAX   ) !" ()
      REAL       GDTG   ( IDIM*JDIM )         !" ɽ̲
      REAL       TAUQ   ( IDIM*JDIM, KMAX+1 ) !" Ū
      REAL       TAUA   ( IDIM*JDIM, KMAX+1 ) !" Ū絤
*
*   [WORK] 
      REAL       TRNSM1 ( IDIM*JDIM, KMAX+1 ) !" 1/2 ٥뤫Ʃ᷸
      REAL       TRNSM2 ( IDIM*JDIM, KMAX+1 ) !" 3/2 ٥뤫Ʃ᷸
*                                                !" ݺ 93/08/29 ɲ
      REAL       TRANS  ( IDIM*JDIM, KMAX+1 ) !" Ʃ᷸
      REAL       ODEPTH ( IDIM*JDIM, KMAX+1 ) !" Ū
      REAL       GDTM   ( IDIM*JDIM, KMAX+1 ) !" (Ⱦ)
      REAL       PIB    ( IDIM*JDIM, KMAX+1 ) !" У¡ң**4
      REAL       PIBGND ( IDIM*JDIM )         !" ɽΦУ
*
*   [INTERNAL PARM] 
      INTEGER    NCLNGD
      PARAMETER (NCLNGD = 10)
      INTEGER    NCLNG                        !" ĹȥХɿ
      REAL       ABSQL  ( NCLNGD )            !" εۼ
      REAL       ABSAL  ( NCLNGD )            !" εۼ
      REAL       RWGTL  ( NCLNGD )            !" Хɥ
      REAL       PATHC                        !" ϩĹΥե
      DATA       NCLNG  / 4 /
      DATA       ABSQL  / 8.0  , 1.0  , 0.1  , 0.0  , 6*0.   /
      DATA       ABSAL  / 0.0  , 0.0  , 0.0  , 5.E-5, 6*0.   /
      DATA       RWGTL  / 0.2  , 0.1  , 0.1  , 0.6  , 6*0.   /
      DATA       PATHC  / 1.5   /
*
      NAMELIST  /NMRADL/ NCLNG , ABSQL , ABSAL , RWGTL , PATHC
      SAVE
*
      LOGICAL    OFIRST
      DATA       OFIRST / .TRUE. /
      SAVE       OFIRST
*
*   [INTERNAL WORK] 
      INTEGER    IJ, K, KK, IC
      INTEGER    IFPAR, JFPAR
      REAL       RUFLUX  ( IDIM*JDIM, KMAX+1 )     !" եå
      REAL       RDFLUX  ( IDIM*JDIM, KMAX+1 )     !" եå
      REAL       UFLUX  ( IDIM*JDIM, KMAX+1 )     !" եå
      REAL       DFLUX  ( IDIM*JDIM, KMAX+1 )     !" եå
      REAL       SUMWGL
      SAVE       RUFLUX,RDFLUX
*
*   [ONCE] 
      IF ( OFIRST ) THEN
         WRITE ( 6,* ) ' LONGWAVE RADIATION N-BAND DATE=93/08/29'
         OFIRST = .FALSE.
*
         CALL   REWNML ( IFPAR , JFPAR )
         READ   ( IFPAR, NMRADL, END=190 )
  190    WRITE  ( JFPAR, NMRADL )
*
         SUMWGL = 0.  
         DO 210 IC = 1, NCLNG
            SUMWGL = SUMWGL + RWGTL( IC )
  210    CONTINUE
         DO 220 IC = 1, NCLNG
            RWGTL( IC ) =  RWGTL( IC ) / SUMWGL
  220    CONTINUE
*
      ENDIF
*
*"         < 1. У¤η׻ >
*
      DO 1100 K = 1, KMAX
         DO 1110 IJ = 1, IDIM*JDIM
            PIB  ( IJ,K ) = STB * ( GDT( IJ,K )**4 )
 1110    CONTINUE
 1100 CONTINUE
*
      DO 1200 IJ = 1, IDIM*JDIM
         PIBGND( IJ ) = STB * ( GDTG( IJ )**4 )
 1200 CONTINUE
*
      CALL RESET ( RUFLUX, IDIM*JDIM*(KMAX+1) )
      CALL RESET ( RDFLUX, IDIM*JDIM*(KMAX+1) )
*
*"         < 1.5 Ūη׻ >
*
      CALL RESET ( ODEPTH, IDIM*JDIM*(KMAX+1) )
*
c$$$      write (6,*) 'in p2rdld:ij,k,odepth'
      DO 1500 IC = 1, NCLNG
         DO 1510 IJ = 1, IDIM*JDIM
            DO 1520 K = 1, KMAX+1
                   ODEPTH( IJ,K )
     &         =   PATHC * (   ABSQL(IC) * TAUQ( IJ,K )
     &                       + ABSAL(IC) * TAUA( IJ,K ) )
c$$$                   write (6,*) ij,k,odepth( ij,k )
 1520       CONTINUE
 1510    CONTINUE
 1500 CONTINUE
*
*"        < ٤ : ٤!!!!>
      DO 1610 IJ = 1,IDIM*JDIM
         GDTM(IJ,1) =  GDTG( IJ )
         DO 1600 K = 2,KMAX
            GDTM(IJ,K) = ( GDT(IJ,K) + GDT(IJ,K-1))/2.0
 1600    CONTINUE
         GDTM(IJ,KMAX+1) = GDT(IJ,KMAX)
 1610 CONTINUE 
*
*"         < 2. Ʃؿ׻ >
*"                 ŪΥη׻ɲáѹ 94/08/23 
*
c$$$      open(unit=71,file='transU',form='unformatted')
c$$$      open(unit=72,file='transD',form='unformatted')
      open(unit=71,file='transU')
      open(unit=72,file='transD')
*
      DO 2000 K = 1, KMAX+1
*
c         write (6,*) 'in p2rdln:k',k
*
         CALL RESET ( TRANS , IDIM*JDIM*(KMAX+1) )
*
         DO 2100 IC = 1, NCLNG
            DO 2110 KK = 1, KMAX+1
               DO 2120 IJ = 1, IDIM*JDIM
                  TRANS( IJ,KK )
     &            = TRANS( IJ,KK )
     &              +  RWGTL ( IC )
     &               * EXP( - ABS ( ODEPTH( IJ,KK )- ODEPTH( IJ,K ) ) )
*"                      weight ΤϤɤ???
*"                      ɤ櫓ʤ. ʤȤ٤.
 2120          CONTINUE
 2110       CONTINUE
 2100    CONTINUE
*
*"      < 3.   ͥեå׻  >       !"  ݺ 93/08/29 ѹ
*
         DO 3100 IJ = 1, IDIM*JDIM
            RUFLUX ( IJ,K ) = PIBGND ( IJ ) * TRANS ( IJ, 1 )
 3100    CONTINUE

c$$$         write (6,*) 'in p2rdld:before flux loop'
          DO 3210 IJ = 1, IDIM*JDIM
             IF( ABS(ODEPTH( IJ,K) - ODEPTH(IJ,K-1)) .LE. 1.0 ) THEN
                DO 3200 KK = 1,K-1
                   RUFLUX( IJ,K ) 
     &                = RUFLUX ( IJ, K ) 
     &                  - PIB ( IJ, KK ) 
     &                    * ( TRANS ( IJ, KK ) - TRANS ( IJ , KK+1 ) ) 
 3200           CONTINUE 
             ELSE 
               IF( K .EQ. 1) THEN
                   RUFLUX( IJ,1 ) = RUFLUX ( IJ, 1 ) 
c$$$                write (6,*) 'upword:ij,k',ij,k
c$$$                write (6,*)
c$$$     &             - pibgnd ( ij ) * EXP ( -  
c$$$     &                ( odepth( IJ,1 ) - ODEPTH( IJ,1) )   ),
c$$$     &             pibgnd ( IJ ),
c$$$     &             stb*( gdtm(IJ,2)**4 - GDTM( IJ,1 )**4 )
c$$$     &               / ( odepth(IJ,2) - ODEPTH( IJ,1 ) )
c$$$     &               *( - ( odepth(IJ,1) - ODEPTH( IJ,1)  + 1.0 ) )
c$$$     &               * exp ( -( odepth(IJ,1) - ODEPTH(IJ,1) ) ),
c$$$     &             stb*( gdtm(IJ,2)**4 - GDTM( IJ,1 )**4 )
c$$$     &               / ( odepth(IJ,2) - ODEPTH( IJ,1 ) )
                ELSE
                   RUFLUX( IJ,K ) 
     &             = RUFLUX ( IJ, K ) 
     &               + PIB ( IJ, K-1 )
     &                * ( - EXP ( - ( ODEPTH( IJ,1 ) - ODEPTH( IJ,K) )
     &                           ) + 1.0 )
     &               + STB * ( GDTM(IJ,K)**4 - GDTM( IJ,K-1 )**4 )
     &                     / ( ODEPTH(IJ,K) - ODEPTH( IJ,K-1) )
     &                 * ( - ( ODEPTH(IJ,1) - ODEPTH( IJ,K) + 1.0 )
     &                       * EXP ( - ( ODEPTH( IJ,1 ) - ODEPTH(IJ,K) )
     &                             )         + 1.0 )
c$$$                write (6,*) 'upword:ij,k',ij,k
c$$$                write (6,*)
c$$$     &             PIB ( IJ, K-1 )
c$$$     &                * EXP ( - ( ODEPTH( IJ,1 ) - ODEPTH( IJ,K) ) ),
c$$$     &             PIB ( IJ, K-1 ),
c$$$     &             stb*( GDTM(IJ,K)**4 - GDTM( IJ,K-1 )**4 )
c$$$     &               / ( ODEPTH(IJ,K) - ODEPTH( IJ,K-1 ) )
c$$$     &               *(  - ( ODEPTH(IJ,1) - ODEPTH( IJ,K)
c$$$     &                   + 1.0 ) )
c$$$     &               * EXP ( - ( ODEPTH(IJ,1) - ODEPTH(IJ,K) ) ),
c$$$     &             stb*( GDTM(IJ,K)**4 - GDTM( IJ,K-1 )**4 )
c$$$     &               / ( ODEPTH(IJ,K) - ODEPTH( IJ,K-1 ) )
                END IF
             END IF
c$$$                if (ij .eq. 32 ) then
c$$$                   write (71,*) ij,k,kk,-(trans(ij,kk)-trans(ij,kk+1))
c$$$                endif
 3210   CONTINUE
*
          DO 3310 IJ = 1, IDIM*JDIM
             IF( ABS(ODEPTH( IJ,K) - ODEPTH(IJ,K+1)) .LE. 1.0 ) THEN
                DO 3300 KK = K, KMAX
                   RDFLUX( IJ,K ) 
     &             = RDFLUX ( IJ, K ) 
     &               + PIB ( IJ, KK ) 
     &                 * ( TRANS ( IJ, KK ) - TRANS ( IJ , KK+1 ) ) 
 3300           CONTINUE 
             ELSE
                IF( K .EQ. 1) THEN
                   RDFLUX( IJ,K ) 
     &             = - PIBGND ( IJ )
     &               * ( EXP ( - ODEPTH( IJ,1 ) ) - 1.0 )
     &            - STB *   ( GDTM(IJ,2)**4 - GDTM( IJ,1 )**4 )
     &                    / ( ODEPTH(IJ,2)  - ODEPTH( IJ,1 )  )
     &               * ( - ( ODEPTH(IJ,1) + 1.0 )
     &                     * EXP ( - ODEPTH( IJ,1 ) )
     &                   + 1.0 )
c$$$                write (6,*) 'downword:ij,k',ij,k
c$$$                write (6,*)
c$$$     &           - pibgnd(ij) * EXP ( - ODEPTH( IJ,1 ) ),
c$$$     &             pibgnd(ij),
c$$$     &           - stb*( GDTM(IJ,2)**4 - GDTM( IJ,1 )**4 )
c$$$     &                /( ODEPTH(IJ,2) - ODEPTH( IJ,1 ) )
c$$$     &               *(- ( ODEPTH(IJ,1) + 1.0)
c$$$     &                   * EXP ( - ODEPTH( IJ,1 ) ) ),
c$$$     &           - stb*( GDTM(IJ,2)**4 - GDTM( IJ,1 )**4 )
c$$$     &                /( ODEPTH(IJ,2) - ODEPTH( IJ,1 ) )
                 ELSE
                   RDFLUX( IJ,K ) 
     &             = - PIB ( IJ, K-1 )
     &               * ( EXP ( - ODEPTH( IJ,K ) ) - 1.0 )
     &            - STB *   ( GDTM(IJ,K)**4 - GDTM( IJ,K-1 )**4 )
     &                    / ( ODEPTH(IJ,K)  - ODEPTH( IJ,K-1 )  )
     &               * ( - ( ODEPTH(IJ,K) + 1.0 )
     &                     * EXP ( - PATHC * ODEPTH( IJ,K ) )
     &                   + 1.0 )
c$$$                write (6,*) 'downword:ij,k',ij,k
c$$$                write (6,*)
c$$$     &           - pib(ij,k-1)
c$$$     &               * EXP ( - ODEPTH( IJ,K ) ),
c$$$     &             pib(ij,k-1),
c$$$     &           - stb*( GDTM(IJ,K)**4 - GDTM( IJ,K-1 )**4 )
c$$$     &                /( ODEPTH(IJ,K) - ODEPTH( IJ,K-1 ) )
c$$$     &               *(- ( ODEPTH(IJ,K) + 1.0)
c$$$     &                   * EXP ( - ODEPTH( IJ,K ) ) ),
c$$$     &           - stb*( GDTM(IJ,K)**4 - GDTM( IJ,K-1 )**4 )
c$$$     &                /( ODEPTH(IJ,K) - ODEPTH( IJ,K-1 ) )
                 END IF
              END IF
c$$$                if (ij .eq. 32 ) then
c$$$                   write (72,*) ij,k,kk,trans(ij,kk)-trans(ij,kk+1)
c$$$                endif
 3310   CONTINUE
*
         DO 3400 KK = K, KMAX+1
            DO 3400 IJ = 1, IDIM*JDIM
                RFLUX( IJ,K ) 
     &             = RUFLUX( IJ, K ) - RDFLUX ( IJ, K ) 
c$$$                write (6,*) 'ij,k,ru,rd',ij,k,ruflux(ij,k),rdflux(ij,k)
 3400   CONTINUE
*
*"       < 4.  ׻Ʃؿ >       !"  ݺ 93/08/29 ѹ
*
        DO 4000 IJ= 1 ,IDIM*JDIM
            TRNSM1 ( IJ,K ) = TRANS( IJ,1 )
            TRNSM2 ( IJ,K ) = TRANS( IJ,2 )
 4000   CONTINUE
*
 2000 CONTINUE
*
*"         < 5. ɽ >               !"  ݺ 93/08/29 ѹ
*
      DO 5100 K = 1, KMAX+1
         DO 5110 IJ = 1, IDIM*JDIM
            DRFLUX( IJ,K,0 ) = 4. * PIBGND( IJ   ) / GDTG  ( IJ )
     &                            * TRNSM1( IJ,K )
            DRFLUX( IJ,K,1 ) = 4. * PIB   ( IJ,1 ) / GDT  ( IJ,1 )
     &                         * ( TRNSM2 ( IJ,K ) - TRNSM1 ( IJ,K ) )      
 5110    CONTINUE
 5100 CONTINUE
*
      close(71)
      close(72)
*
      RETURN
***************************************************************
      ENTRY UDFLUX
     O      (UFLUX,DFLUX)
*
*"                             94/08/05 ɲ 
*
      CALL COPY (UFLUX,RUFLUX,IDIM*JDIM*(KMAX+1))
      CALL COPY (DFLUX,RDFLUX,IDIM*JDIM*(KMAX+1))
*
      END
