* PACKAGE P2GRST      !" ʪ(2) ˰
*
*"  [HIS] 95/09/22(ishiwatari)
*"        95/10/05(ishiwatari) ˸Фޤ
*"        95/10/30(ishiwatari) ǥХå, ؤǼ¹
*"        95/10/30(ishiwatari) U, V ˤĤƤ¹Ԥ
*
**********************************************************************
      SUBROUTINE GRVSAT   !" ˰
     M         ( GDT   , GDU   , GDV   ,
     O           GTGS  , GUGS  , GVGS  ,
     I           GDTM  , GDP   , GDPM  , DELTA  )
*
*" ؤĴ᤹(U, V, T). 
*"  3 ȥꥪĴᤷƤ, Ϥ 3 ˤФޤ.
*" p2grst.F ǤϤ.
*
*   [PARAM] 
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                      !" ʻȿ
      INCLUDE   (ZCCOM)                      !" ɸʪ
#else
#include        "zcdim.F"                    !" ʻȿ
#include        "zccom.F"                    !" ɸʪ
#endif
*
*   [MODIFY] 
      REAL       GDT   ( IDIM*JDIM, KMAX )   !"   
      REAL       GDU   ( IDIM*JDIM, KMAX )   !" 
      REAL       GDV   ( IDIM*JDIM, KMAX )   !" 
*
*   [INPUT] 
      REAL       GDP   ( IDIM*JDIM, KMAX )   !"   
      REAL       GDPM  ( IDIM*JDIM, KMAX+1 ) !" Ⱦ
      REAL       GDTM  ( IDIM*JDIM, KMAX+1 ) !" ١Ⱦ
      REAL       DELTA                       !" 2 t
*
*   [OUTPUT] 
      REAL       GTGS   ( IDIM*JDIM, KMAX )   !" ѲΨ
      REAL       GUGS   ( IDIM*JDIM, KMAX )   !" ѲΨ
      REAL       GVGS   ( IDIM*JDIM, KMAX )   !" ѲΨ
*
*   [INTERNAL PARM] 
      REAL       FGS                         !" Ĵ᤹ٹ
      REAL       FGSU                        !" Ĵ᤹ٹ(u,v)
      INTEGER    KMINGS                      !" Ĵᳫϥ٥
      INTEGER    KMAXGS                      !" ĴὪλ٥
      DATA       FGS    / 0.1 /
      DATA       FGSU   / 0.1 /
      DATA       KMINGS / 2   /
*"          :KMAXGS ΥǥեͤϲǷ.
*
      NAMELIST /NMGRST/ FGS, FGSU, KMINGS, KMAXGS
      LOGICAL    OFIRST
      DATA       OFIRST / .TRUE. /
      SAVE
*
*   [INTERNAL WORK] 
      COMMON    /COMWRK/
     &           DELP, TB, UB, VB, GDTB, GDUB, GDVB
      REAL       DELP  ( IDIM*JDIM, KMAX )   !" 
      REAL       TB    ( IDIM*JDIM, KMAX )   !" T ܾ
      REAL       UB    ( IDIM*JDIM, KMAX )   !" T ܾ
      REAL       VB    ( IDIM*JDIM, KMAX )   !" T ܾ
      REAL       GDTB  ( IDIM*JDIM, KMAX )   !" (Ĵ)
      REAL       GDUB  ( IDIM*JDIM, KMAX )   !" (Ĵ)
      REAL       GDVB  ( IDIM*JDIM, KMAX )   !" (Ĵ)
      INTEGER    IJ, K, K1
      INTEGER    IFPAR, JFPAR
      REAL       SUMTDP, SUMUDP, SUMVDP, SUMADP
*
*   [ONCE] 
      IF ( OFIRST ) THEN
         WRITE ( 6,* ) ' GRAVITY WAVE SATURATION P2.1 DATE=95/10/09'
         OFIRST = .FALSE.
*
         KMAXGS = KMAX-1
*
         CALL   REWNML ( IFPAR , JFPAR )
         READ   ( IFPAR, NMGRST, END=190 )
  190    WRITE  ( JFPAR, NMGRST )
*
      ENDIF
*
*"      < 1. ե׻ >
*
      DO 1120 K = 1, KMAX
         DO 1110 IJ = 1, IDIM*JDIM
            DELP  ( IJ,K ) = GDPM( IJ,K   ) - GDPM( IJ,K+1 )
            TB    ( IJ,K ) = (GDTM( IJ,K ) + GDTM( IJ,K+1 ))/2.0
 1110    CONTINUE
 1120 CONTINUE
*
      DO 1140 IJ = 1, IDIM*JDIM
         UB    ( IJ,1 ) = ( 3.0 * GDU( IJ,1 ) + GDU( IJ,2 )
     &                        )/4.0
         VB    ( IJ,1 ) = ( 3.0 * GDV( IJ,1 ) + GDV( IJ,2 )
     &                         )/4.0
         DO 1130 K = 2, KMAX-1
            UB    ( IJ,K ) = ( GDU( IJ,K-1 ) + 2.0 * GDU( IJ,K )
     &                         + GDU( IJ,K+1 ) )/4.0
            VB    ( IJ,K ) = ( GDV( IJ,K-1 ) + 2.0 * GDV( IJ,K )
     &                         + GDV( IJ,K+1 ) )/4.0
 1130    CONTINUE
         UB    ( IJ,KMAX ) = ( GDU( IJ,KMAX-1 ) + 3.0 * GDU( IJ,KMAX )
     &                          )/4.0
         VB    ( IJ,KMAX ) = ( GDV( IJ,KMAX-1 ) + 3.0 * GDV( IJ,KMAX )
     &                          )/4.0
 1140 CONTINUE
*
      DO 1160 K=1,KMAX
         DO 1150 IJ=1, IDIM*JDIM
            GDTB(IJ,K) = GDT(IJ,K)
            GDUB(IJ,K) = GDU(IJ,K)
            GDVB(IJ,K) = GDV(IJ,K)
 1150    CONTINUE 
 1160 CONTINUE 
*
*"      < 2. Ĵ >
*
      CALL RESET ( GTGS, IDIM*JDIM*KMAX )
      CALL RESET ( GUGS, IDIM*JDIM*KMAX )
      CALL RESET ( GVGS, IDIM*JDIM*KMAX )
*
      SUMTDP=0.0
      SUMADP=0.0
*
      DO 2110 K = KMINGS, KMAXGS
         DO 2120 IJ = 1, IDIM*JDIM
            SUMTDP =  (TB(IJ,K-1) - GDT(IJ,K-1) ) * DELP(IJ,K-1)
     &              + (TB(IJ,K  ) - GDT(IJ,K  ) ) * DELP(IJ,K  )
     &              + (TB(IJ,K+1) - GDT(IJ,K+1) ) * DELP(IJ,K+1)
            SUMUDP =  (UB(IJ,K-1) - GDU(IJ,K-1) ) * DELP(IJ,K-1)
     &              + (UB(IJ,K  ) - GDU(IJ,K  ) ) * DELP(IJ,K  )
     &              + (UB(IJ,K+1) - GDU(IJ,K+1) ) * DELP(IJ,K+1)
            SUMVDP =  (VB(IJ,K-1) - GDV(IJ,K-1) ) * DELP(IJ,K-1)
     &              + (VB(IJ,K  ) - GDV(IJ,K  ) ) * DELP(IJ,K  )
     &              + (VB(IJ,K+1) - GDV(IJ,K+1) ) * DELP(IJ,K+1)
            SUMADP =  DELP(IJ,K-1) + DELP(IJ,K) + DELP(IJ,K+1)
*
            GDT(IJ,K-1) = GDT(IJ,K-1)
     &                    + FGS*(   TB(IJ,K-1) - GDT(IJ,K-1) 
     &                            - SUMTDP/SUMADP )
            GDU(IJ,K-1) = GDU(IJ,K-1)
     &                    + FGSU*(   UB(IJ,K-1) - GDU(IJ,K-1) 
     &                            - SUMUDP/SUMADP )
            GDV(IJ,K-1) = GDV(IJ,K-1)
     &                    + FGSU*(   VB(IJ,K-1) - GDV(IJ,K-1) 
     &                            - SUMVDP/SUMADP )
*
            GDT(IJ,K) = GDT(IJ,K)
     &                    + FGS*(   TB(IJ,K) - GDT(IJ,K) 
     &                            - SUMTDP/SUMADP )
            GDU(IJ,K) = GDU(IJ,K)
     &                    + FGSU*(   UB(IJ,K) - GDU(IJ,K) 
     &                            - SUMUDP/SUMADP )
            GDV(IJ,K) = GDV(IJ,K)
     &                    + FGSU*(   VB(IJ,K) - GDV(IJ,K) 
     &                            - SUMVDP/SUMADP )
*
            GDT(IJ,K+1) = GDT(IJ,K+1) 
     &                    + FGS*(   TB(IJ,K+1) - GDT(IJ,K+1) 
     &                            - SUMTDP/SUMADP )
            GDU(IJ,K+1) = GDU(IJ,K+1) 
     &                    + FGSU*(   UB(IJ,K+1) - GDU(IJ,K+1) 
     &                            - SUMUDP/SUMADP )
            GDV(IJ,K+1) = GDV(IJ,K+1) 
     &                    + FGSU*(   VB(IJ,K+1) - GDV(IJ,K+1) 
     &                            - SUMVDP/SUMADP )
 2120    CONTINUE
 2110 CONTINUE
*
      DO 2210 K=1,KMAX
         DO 2220 IJ = 1, IDIM*JDIM
            GTGS(IJ,K) = ( GDT(IJ,K) - GDTB(IJ,K) )/DELTA
            GUGS(IJ,K) = ( GDU(IJ,K) - GDUB(IJ,K) )/DELTA
            GVGS(IJ,K) = ( GDV(IJ,K) - GDVB(IJ,K) )/DELTA
 2220    CONTINUE
 2210 CONTINUE
*
      RETURN
      END
