* PACKAGE P2SFCL  !" ʪ(2) ɽХ륯
*                 !" ǮեåȸǮեåǰۤʤ TG
*                 !" 96/10/28 (M. Ishiwatari)
***********************************************************************
      SUBROUTINE BLKCOF          !" Х륯
     O         ( CM    , CH    , CE    ,
     I           RIB   , RIBE  , RIBS  ,
     I           VABS  , GRZ0M , GRZ0H , ZA    )
*
*"         Luois Bulk Coeff.
*
*   [PARAM] 
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                      !" ʻ, ȿ
      INCLUDE   (ZCCOM)                      !" ɸʪ
#else
#include        "zcdim.F"                    !" ʻ, ȿ
#include        "zccom.F"                    !" ɸʪ
#endif
*
*   [OUTPUT] 
      REAL       CM    ( IDIM*JDIM )         !" Х륯
      REAL       CH    ( IDIM*JDIM )         !" Х륯
      REAL       CE    ( IDIM*JDIM )         !" Х륯
*
*   [INPUT] 
      REAL       RIB   ( IDIM*JDIM )         !" ң
      REAL       RIBE  ( IDIM*JDIM )         !" ң(Ǯ)
      REAL       RIBS  ( IDIM*JDIM )         !" ң(Ǯ)
      REAL       VABS  ( IDIM*JDIM )         !" ®
      REAL       GRZ0M ( IDIM*JDIM )         !" ɽ١ʱư̡
      REAL       GRZ0H ( IDIM*JDIM )         !" ɽ١Ǯ
      REAL       ZA    ( IDIM*JDIM )         !" ǲع
*
*   [INTERNAL PARM] 
      LOGICAL    NEWTRL
      DATA       NEWTRL / .FALSE. /
      REAL       CHCONS
      REAL       CMMIN, CHMIN, CEMIN
      REAL       CMMAX, CHMAX, CEMAX
      DATA       CHCONS /  -1.   /
      DATA       CMMIN  /   0.   /           !" Х륯Ǿ
      DATA       CHMIN  /   0.   /           !" ԥХ륯Ǿ
      DATA       CEMIN  /   0.   /           !" Х륯Ǿ
      DATA       CMMAX  /   1.   /           !" Х륯
      DATA       CHMAX  /   1.   /           !" ԥХ륯
      DATA       CEMAX  /   1.   /           !" Х륯
*
      NAMELIST  /NMSFCL/ NEWTRL, CHCONS,
     &                   CMMIN , CHMIN , CEMIN ,
     &                   CMMAX , CHMAX , CEMAX
*
      LOGICAL    OFIRST
      DATA       OFIRST / .TRUE. /
      SAVE
*
*   [INTERNAL WORK] 
      INTEGER    IJ
      INTEGER    IFPAR, JFPAR
*
*   [ONCE] 
      IF ( OFIRST ) THEN
         WRITE ( 6,* ) ' SURFACE BULK COEF. Louis - P2.1 DATE=90/11/19'
         OFIRST = .FALSE.
*
         CALL   REWNML ( IFPAR , JFPAR )
         READ   ( IFPAR, NMSFCL, END=190 )
  190    WRITE  ( JFPAR, NMSFCL )
*
      ENDIF
*
*"         < 1. ΩХ륯 >
*
      IF ( CHCONS .LT. 0.   ) THEN
*
         DO 1100 IJ = 1, IDIM*JDIM
            CM ( IJ ) = (  FKARM / LOG( ZA( IJ )/GRZ0M( IJ ) )  )**2
            CH ( IJ ) = (  FKARM / LOG( ZA( IJ )/GRZ0H( IJ ) )  )**2
            CE ( IJ ) = CH ( IJ )
 1100    CONTINUE
*
      ELSE
         DO 1200 IJ = 1, IDIM*JDIM
            CM ( IJ ) = CHCONS
            CH ( IJ ) = CHCONS
            CE ( IJ ) = CHCONS
 1200    CONTINUE
      ENDIF
*
*"         < 2. Ω >
*
      IF ( .NOT. NEWTRL ) THEN
*
         DO 2100 IJ = 1, IDIM*JDIM
*
            IF ( RIB( IJ ) .GT. 0.   ) THEN
               CM ( IJ ) = CM ( IJ )
     &                     / ( 1. + 10.*RIB( IJ )
     &                                / SQRT( 1.+5.*RIB( IJ ) )  )
            ELSE
               CM ( IJ ) = CM ( IJ )
     &                     * ( 1. - 10.*RIB( IJ )
     &                             / ( 1. + 75.*CM( IJ )
     &                                    * SQRT( -ZA( IJ )/GRZ0M( IJ )
     &                                          * RIB( IJ )            )
     &                             )
     &                    )
            ENDIF
*
            IF ( RIBS( IJ ) .GT. 0.   ) THEN
               CH ( IJ ) = CH ( IJ )
     &                     / ( 1. + 15.*RIBS( IJ )
     &                                * SQRT( 1.+5.*RIBS( IJ ) )  )
            ELSE
               CH ( IJ ) = CH ( IJ )
     &                     * ( 1. - 15.*RIB( IJ )
     &                             / ( 1. + 75.*CH( IJ )
     &                                    * SQRT( -ZA( IJ )/GRZ0H( IJ )
     &                                          * RIBS( IJ )           )
     &                             )
     &                    )
            ENDIF
*
            IF ( RIBE( IJ ) .GT. 0.   ) THEN
               CE ( IJ ) = CE ( IJ )
     &                     / ( 1. + 15.*RIBE( IJ )
     &                                * SQRT( 1.+5.*RIBE( IJ ) )  )
            ELSE
               CE ( IJ ) = CE ( IJ )
     &                     * ( 1. - 15.*RIBE( IJ )
     &                             / ( 1. + 75.*CH( IJ )
     &                                    * SQRT( -ZA( IJ )/GRZ0H( IJ )
     &                                          * RIBE( IJ )           )
     &                             )
     &                    )
            ENDIF
*
 2100    CONTINUE
*
      ENDIF
*
      DO 2200 IJ = 1, IDIM*JDIM
         CM ( IJ ) = MAX(  MIN( CM ( IJ ), CMMAX ), CMMIN  )
         CH ( IJ ) = MAX(  MIN( CH ( IJ ), CHMAX ), CHMIN  )
         CE ( IJ ) = MAX(  MIN( CE ( IJ ), CEMAX ), CEMIN  )
 2200 CONTINUE
*
      RETURN
      END
